# Safecracker
##### Time Limit : 2000/1000ms (Java/Other) Memory Limit : 65536/32768K (Java/Other)
##### Total Submission(s) : 3 Accepted Submission(s) : 1
Problem Description
=== Op tech briefing, 2002/11/02 06:42 CST ===
"The item is locked in a Klein safe behind a painting in the second-floor library. Klein safes are extremely rare; most of them, along with Klein and his factory, were destroyed in World War II. Fortunately old Brumbaugh from research knew Klein's secrets and wrote them down before he died. A Klein safe has two distinguishing features: a combination lock that uses letters instead of numbers, and an engraved quotation on the door. A Klein quotation always contains between five and twelve distinct uppercase letters, usually at the beginning of sentences, and mentions one or more numbers. Five of the uppercase letters form the combination that opens the safe. By combining the digits from all the numbers in the appropriate way you get a numeric target. (The details of constructing the target number are classified.) To find the combination you must select five letters v, w, x, y, and z that satisfy the following equation, where each letter is replaced by its ordinal position in the alphabet (A=1, B=2, ..., Z=26). The combination is then vwxyz. If there is more than one solution then the combination is the one that is lexicographically greatest, i.e., the one that would appear last in a dictionary."
v - w^2 + x^3 - y^4 + z^5 = target
"For example, given target 1 and letter set ABCDEFGHIJKL, one possible solution is FIECB, since 6 - 9^2 + 5^3 - 3^4 + 2^5 = 1. There are actually several solutions in this case, and the combination turns out to be LKEBA. Klein thought it was safe to encode the combination within the engraving, because it could take months of effort to try all the possibilities even if you knew the secret. But of course computers didn't exist then."
=== Op tech directive, computer division, 2002/11/02 12:30 CST ===
"Develop a program to find Klein combinations in preparation for field deployment. Use standard test methodology as per departmental regulations. Input consists of one or more lines containing a positive integer target less than twelve million, a space, then at least five and at most twelve distinct uppercase letters. The last line will contain a target of zero and the letters END; this signals the end of the input. For each line output the Klein combination, break ties with lexicographic order, or 'no solution' if there is no correct combination. Use the exact format shown below."
Sample Input
~~~
1 ABCDEFGHIJKL
11700519 ZAYEXIWOVU
3072997 SOUGHT
1234567 THEQUICKFROG
0 END
~~~
Sample Output
~~~
LKEBA
YOXUZ
GHOST
no solution
~~~
1.lexicographical order:cap < card < cat < to < too< two < up
2.其实是个组合问题12*11*10*9*8大约十几万次当然5个循环不超时,用搜索的形式写的时候因为递归和回溯耗时,所以超时
3.代码:
~~~
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;
int t;
char s[20];
int a[10];
int len;
bool flag;
int cmp(int a,int b)
{
return a>b;
}
void Find()
{
for(int i=1; i<=len; i++)
{
a[1]=s[i]-'A'+1;
for(int j=1; j<=len; j++)
{
if(i==j)
continue;
a[2]=s[j]-'A'+1;
for(int k=1; k<=len; k++)
{
if(j==k||k==i)
continue;
a[3]=s[k]-'A'+1;
for(int l=1; l<=len; l++)
{
if(l==k||l==j||l==i)
continue;
a[4]=s[l]-'A'+1;
for(int m=1; m<=len; m++)
{
if(m==l||m==k||m==j||m==i)
continue;
a[5]=s[m]-'A'+1;
if(a[1]-a[2]*a[2]+a[3]*a[3]*a[3]-a[4]*a[4]*a[4]*a[4]+a[5]*a[5]*a[5]*a[5]*a[5]==t)
{
flag=1;
break;
}
}
if(flag)
break;
}
if(flag)
break;
}
if(flag)
break;
}
if(flag)
break;
}
}
int main()
{
while(scanf("%d%s",&t,s+1)==2)
{
if(t==0&&strcmp("END",s+1)==0)
{
break;
}
else
{
len=strlen(s+1);
flag=0;
sort(s+1,s+1+len,cmp);//保证答案是字典序上最大
Find();
if(flag)
printf("%c%c%c%c%c\n",a[1]+'A'-1,a[2]+'A'-1,a[3]+'A'-1,a[4]+'A'-1,a[5]+'A'-1);
else
printf("no solution\n");
}
}
return 0;
}
~~~
- 前言
- The 12th Zhejiang Provincial Collegiate Programming Contest - D
- 用邻接表存储n个顶点m条弧的有向图
- hdu 5289 Assignment(给一个数组,求有多少个区间,满足区间内的最大值和最小值之差小于k)
- hdu 1358 Period(给定一个字符串,求有多少个前缀(包括自己本身),它是由k(k&gt;2,并且尽量大)个循环节组成的)
- hdu 1806 Frequent values(给定一个非降序数组,求任意区间内出现次数最多的数的次数)
- poj 3264 Balanced Lineup(查询区间最大值与最小值的差)
- HDU 1010 Tempter of the Bone(DFS+奇偶剪枝)
- HDU 1015 Safecracker(第一次用了搜索去遍历超时,第二次用for循环可以了,思路一样的)
- HDU 1016 Prime Ring Problem(DFS)
- HDU 1026 Ignatius and the Princess I(BFS+记录路径)
- HDU 1072 Nightmare(BFS)
- HDU 1237 简单计算器(后缀式+栈)